[![返回目录](https://parg.co/UGo)](https://parg.co/b4z) 


# 深度学习资料索引


# Overview:概论

- [2017-The Deep Learning Roadmap](https://medium.com/intuitionmachine/the-deep-learning-roadmap-f0b4cac7009a).

- [2017-深度学习简史](http://6me.us/d3t)：一部深度学习的简史，虽然不那么波澜壮阔，但其发展也是一波三折，艰难而行。随着AlphaGo掀起的人工智能新浪潮，人工智能的春天才刚刚开始。希望本文为大家了解深度学习的历史，理解深度学习的本质带来帮助。

- [李宏毅:Deep Learning Tutorial](https://drive.wps.cn/view/l/a034b6d643e7455fa1b533ded239acd1):300多页的PPT深入浅出地介绍了深度学习的基本概念。


- [我如何理解深度学习？](http://www.afenxi.com/post/38176?utm_source=tuicool&utm_medium=referral)

- [有趣的机器学习概念纵览：从多元拟合，神经网络到深度学习，给每个感兴趣的人](https://segmentfault.com/a/1190000005746236)

- [深层学习为何要“Deep”（上）](https://zhuanlan.zhihu.com/p/22888385)

- [Deep-Learning-Papers-Reading-Roadmap](https://github.com/songrotek/Deep-Learning-Papers-Reading-Roadmap):为每个对深度学习感兴趣的朋友整理的论文阅读路线图


- [程序员的深度学习入门指南](http://mp.weixin.qq.com/s?__biz=MzA4ODMwMDcxMQ==&mid=2650891687&idx=1&sn=5cacb7cc40907c4b3080f95a2f007396&chksm=8bd9886fbcae0179ffb26e77cf448827870827fb24c3b4c6df7889f46ae59955f278eccba19a&mpshare=1&scene=2&srcid=1107xRQnB44aPEpI8Tvtatls&from=timeline&isappinstalled=0#wechat_redirect):来自费良宏在2016QCon全球软件开发大会（上海）上的演讲。

- [2017-深度神经网络全面概述：从基本概念到实际模型和硬件基础](https://parg.co/bC6)：深度神经网络（DNN）所代表的人工智能技术被认为是这一次技术变革的基石（之一）。近日，由 IEEE Fellow Joel Emer 领导的一个团队发布了一篇题为《深度神经网络的有效处理：教程和调研（Efficient Processing of Deep Neural Networks: A Tutorial and Survey）》的综述论文，从算法、模型、硬件和架构等多个角度对深度神经网络进行了较为全面的梳理和总结。。



- [Deep Learning 101【Series】](http://beamandrew.github.io/deeplearning/2017/02/23/deep_learning_101_part1.html): The Deep Learning 101 series is a companion piece to a talk given as part of the Department of Biomedical Informatics @ Harvard Medical School ‘Open Insights’ series. Slides for the talk are available here



## 神经网络基础

- [Deep Learning Basics: Neural Networks, Backpropagation and Stochastic Gradient Descent](http://alexminnaar.com/deep-learning-basics-neural-networks-backpropagation-and-stochastic-gradient-descent.html) 

- [[翻译] 神经网络的直观解释](http://www.hackcv.com/index.php/archives/104/?hmsr=toutiao.io&utm_medium=toutiao.io&utm_source=toutiao.io):卷积神经网络的讲解非常通俗易懂。


## 盘点与回顾

- [Deep Learning 2016: The Year in Review](http://www.deeplearningweekly.com/blog/deep-learning-2016-the-year-in-review)


- [The limitations of deep learning](https://blog.keras.io/the-limitations-of-deep-learning.html): This post is targeted at people who already have significant experience with deep learning (e.g. people who have read chapters 1 through 8 of the book). We assume a lot of pre-existing knowledge.




# Collection: 资料索引



- [Deep Learning for Noobs [Part 1]](https://hackernoon.com/supervised-deep-learning-in-image-classification-for-noobs-part-1-9f831b6d430d#.byiv0mk3u)


- [Awesome - Most Cited Deep Learning Papers【Paper】](https://github.com/terryum/awesome-deep-learning-papers)

- [126篇殿堂级深度学习论文分类整理 从入门到应用](https://zhuanlan.zhihu.com/p/25549497)：昵称为 songrotek 的学霸在 GitHub 发布了他整理的深度学习路线图，分门别类梳理了新入门者最需要学习的 DL 论文，又按重要程度给每篇论文打上星星。

- [利用Python进行深度学习的完整入门指南(附资源)](http://6me.us/uSk) 

- [learn-blog](https://github.com/ironman5366/learn-blog): Machine learning for humans Helping you learn Ml the easy way using keras.io


# Book: 书籍

- [2016-Deep Learning By Ian Goodfellow, Yoshua Bengio and Aaron Courville](https://github.com/HFTrader/DeepLearningBook): 中文译本[这里](https://pan.baidu.com/s/1o8boqdc)。The Deep Learning textbook is a resource intended to help students and practitioners enter the field of machine learning in general and deep learning in particular. The online version of the book is now complete and will remain available online for free. The print version will be available for sale soon.

- [Stanford Deep Learning Tutorial【Book】](http://deeplearning.stanford.edu/tutorial/): This tutorial will teach you the main ideas of Unsupervised Feature Learning and Deep Learning. By working through it, you will also get to implement several feature learning/deep learning algorithms, get to see them work for yourself, and learn how to apply/adapt these ideas to new problems.

- [2016-Neural Networks and Deep Learning【Book】](http://neuralnetworksanddeeplearning.com/): Neural Networks and Deep Learning is a free online book. The book will teach you about: (1) Neural networks, a beautiful biologically-inspired programming paradigm which enables a computer to learn from observational data. (2) Deep learning, a powerful set of techniques for learning in neural networks.

- [深度学习入门【Book】](https://github.com/PaddlePaddle/book/blob/develop/README.md)：您现在在看的这本书是一本“交互式”电子书 —— 每一章都可以运行在一个 Jupyter Notebook 里。 我们把 Jupyter、PaddlePaddle、以及各种被依赖的软件都打包进一个 Docker image 了。所以您不需要自己来安装各种软件，只需要安装 Docker 即可。


# Course: 视频课程



- [Practical Deep Learning For Coders -FastAI【Course】](http://course.fast.ai/index.html)：fast.ai 提供的七周的免费深度学习课程，学习如何构建那些优秀的模型；目前已经包含了[ Part 1 ](http://course.fast.ai/)、[ Part 2 ](http://course.fast.ai/part2.html)。 
    
- [fastai](https://github.com/fastai/fastai): The fast.ai deep learning library, lessons, and tutorials. 




- [Oxford Deep NLP 2017 course【Course】](https://github.com/oxford-cs-deepnlp-2017/lectures): This is an advanced course on natural language processing. Automatically processing natural language inputs and producing language outputs is a key component of Artificial General Intelligence.

- [2017-DeepLearning AI【Course】](https://github.com/fastai/fastai)


# Case: 案例

- [2017-The-Terrible-Deep-Learning-List](https://github.com/samdeeplearning/The-Terrible-Deep-Learning-List): 15 working examples to get you started with Deep Learning without learning any of the math.

- [Miles Deep - AI Porn Video Editor](https://github.com/ryanjay0/miles-deep)



## Funny DeepLearning



- [Using Keras and Deep Q-Network to Play FlappyBird](https://yanpanlau.github.io/2016/07/10/FlappyBird-Keras.html)



# Toolkits: 工具

- [Evaluation of Deep Learning Toolkits](https://github.com/zer0n/deepframeworks)

- [代码解析深度学习系统编程模型：TensorFlow vs. CNTK](http://geek.csdn.net/news/detail/62429?utm_source=tuicool&utm_medium=referral)

- [tensorflow-playground](https://github.com/tensorflow/playground):Play with neural networks! 

- [dl-docker](https://github.com/saiprashanths/dl-docker):将常用的深度学习工具打包在了一个Docker镜像中


- [deep-learning-models](https://github.com/fchollet/deep-learning-models):Keras code and weights files for popular deep learning models.

- [Top Deep Learning Projects](https://github.com/aymericdamien/TopDeepLearning)

- [neurojs](https://github.com/janhuenermann/neurojs): neurojs is a JavaScript framework for deep learning in the browser. It mainly focuses on reinforcement learning, but can be used for any neural network based task. It contains neat demos to visualise these capabilities, for instance a 2D self-driving car.


# Others:其他

- [深度学习岗位面试问题整理笔记](https://zhuanlan.zhihu.com/p/25005808)