[![返回目录](https://parg.co/UGo)](https://parg.co/b4z) 


# 机器学习资料索引




# Overview:概论

- [白话解释机器学习基本概念](https://zhuanlan.zhihu.com/p/24346657) 

- [Visual Intro To Machine Learning](http://www.r2d3.us/visual-intro-to-machine-learning-part-1/):图解如何基于决策树对于纽约与San Francisco的房产进行分类

- [A Gentle Guide to Machine Learning](https://blog.monkeylearn.com/a-gentle-guide-to-machine-learning/)

- [Machine Learning basics for a newbie](https://www.analyticsvidhya.com/blog/2015/06/machine-learning-basics/)

- [What is machine learning, and how does it work?](https://www.youtube.com/watch?v=elojMnjn4kk&list=PL5-da3qGB5ICeMbQuqbbCOQWcS6OYBr5A&index=1) 

- [学术丨周志华：机器学习有这两大派别，新人入门别跟错队](https://getpocket.com/a/read/1611824209)

- [Machine Learning: An In-Depth Guide【Series】](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide/): [Overview, Goals, Learning Types, and Algorithms](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide/)、[Data selection, preparation, and modeling](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide-part-2/)、[Model evaluation, validation, complexity, and improvement](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide-part-3/)、[Model performance and error analysis](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide-part-4/)、[Unsupervised learning, related fields, and machine learning in practice](http://www.innoarchitech.com/machine-learning-an-in-depth-non-technical-guide-part-5/)

- [Machine Learning Mindmap / Cheatsheet](https://github.com/dformoso/machine-learning-mindmap): A Mindmap summarising Machine Learning concepts, from Data Analysis to Deep Learning.

- [How To Become A Machine Learning Engineer: Learning Path](https://hackernoon.com/learning-path-for-machine-learning-engineer-a7d5dc9de4a4): We will walk you through all the aspects of machine learning from simple linear regressions to the latest neural networks, and you will learn not only how to use them but also how to build them from scratch.


## Algorithms:算法

- [10 Machine Learning Algorithms Explained to an ‘Army Soldier’](https://www.analyticsvidhya.com/blog/2015/12/10-machine-learning-algorithms-explained-army-soldier/)

- [Top 10 data mining algorithms in plain English](https://rayli.net/blog/data/top-10-data-mining-algorithms-in-plain-english/)

- [10 Machine Learning Terms Explained in Simple English](http://blog.aylien.com/10-machine-learning-terms-explained-in-simple/)

- [A Tour of Machine Learning Algorithms](http://machinelearningmastery.com/a-tour-of-machine-learning-algorithms/)

- [The 10 Algorithms Machine Learning Engineers Need to Know](https://gab41.lab41.org/the-10-algorithms-machine-learning-engineers-need-to-know-f4bb63f5b2fa#.ofc7t2965)

- [Comparing supervised learning algorithms](http://www.dataschool.io/comparing-supervised-learning-algorithms/) 

- [Categories of Machine Learning Algorithms](https://static.coggle.it/diagram/WHeBqDIrJRk-kDDY) 




## Mathematics

- [The Mathematics of Machine Learning](http://www.datasciencecentral.com/profiles/blogs/the-mathematics-of-machine-learning)




# Book:书籍

- [2015 - Python Data Science Handbook](https://github.com/jakevdp/PythonDataScienceHandbook?utm_source=mybridge&utm_medium=web&utm_campaign=read_more):Jupyter Notebooks for the Python Data Science Handbook


- [2014 - DataScience From Scratch](https://drive.wps.cn/view/l/5f44c391b0d74b798122ebb4655cad22)

- [2012 - 李航:统计方法学](https://drive.wps.cn/view/l/ccfc95e5c9ba42db8cbcbb6507d85d1d)

- [2015 - Data Mining, The Textbook](https://drive.wps.cn/view/l/57c1ef99942b4cb789ed464a189df6c0)

- [2016 - 周志华 机器学习](https://drive.wps.cn/view/l/004e86e89e4347fcb1e10569a35295a3)

- [2012 - Machine Learning A Probabilistic Perspective ](https://drive.wps.cn/view/l/8a5acb26d91f4008b425430eae8565fb)

- [2012 - 深入浅出机器学习 中文版](https://drive.wps.cn/view/l/215ff72bda3f4054b1b7e50fc9a2ee30) 


# Video Course:视频教程



- [University of Illinois at Urbana-Champaign:Text Mining and Analytics](https://zh.coursera.org/learn/text-mining)

- [台大机器学习技法](https://www.youtube.com/playlist?list=PLXVfgk9fNX2IQOYPmqjqWsNUFl2kpk1U2)

- [斯坦福 机器学习课程](https://zh.coursera.org/learn/machine-learning)


- [CS224d: Deep Learning for Natural Language Processing](http://cs224d.stanford.edu/syllabus.html) 

- [Unsupervised Feature Learning and Deep Learning](http://ufldl.stanford.edu/wiki/index.php/UFLDL_Tutorial):来自斯坦福的无监督特征学习与深度学习系列教程




# 算法与实现



- [Fundamental Tools for Machine Learning](https://toolsformachinelearning.blogspot.hk/2017/02/introduction-machine-learning-is.html)


- [MLAlgorithms](https://github.com/rushter/MLAlgorithms):Minimal and clean examples of machine learning algorithms

- [data-science-ipython-notebooks](https://github.com/donnemartin/data-science-ipython-notebooks):一系列基于IPython的数据科学代码展示


- [The Open Source Data Science Masters](https://github.com/datasciencemasters/go)

- [ML-From-Scratch](https://github.com/eriklindernoren/ML-From-Scratch): Bare bones Python implementations of various Machine Learning models and algorithms.



# Career:职业


## Interview:面试

- [想知道机器学习掌握的怎么样了吗？这有一份自测题（附答案和解析）](https://yq.aliyun.com/articles/64929)
