[![返回目录](https://parg.co/UGo)](https://parg.co/b4z)





# Java 学习与实践资料索引


当我们谈起 Java 的时候，往往是将其作为一门编程语言来讨论；然而编程语言的特性只是 Java 架构的某部分，保障其平台独立性的一系列底层架构也是 Java 不可分割的组成。宏观来看，我们认为 Java 主要包含以下四个部分：Java 编程语言、Java 类文件格式、Java API 以及 JVM。当我们在进行 Java 开发时，我们使用 Java 编程语言来编写代码，然后将其编译为 Java 类文件，最终在 JVM 中执行这些类文件；目前我们也可以使用 Gradle、Kotlin 等其他优秀的语言来编写 Java 应用程序。而 JVM 与 Java 平台的核心库就构成了我们所熟知的 Java Runtime Environment（JRE）：


![](https://coding.net/u/hoteam/p/Cache/git/raw/master/2017/8/1/java.png)


作为主流的编程语言之一，Java 走过了二十余载的路程；从 Java 8 到 Java 9，其语法特性与开发模式也处于不断地迭代当中。本文即是希望对于不断变化的并且在实际工作中大量应用的 Java 学习与实践的资料进行收集与索引；鉴于本部分正在不断完善，以下链接可能存在疏漏，请直接查看本目录下其他文件获取信息：[Java 语法基础资料索引，Java 数据结构资料索引，Java 集合资料索引，Java 并发编程资料索引，JVM 资料索引]()


# Overview: 概述



- [2017-细思极恐-你真的会写java吗?](http://6me.us/IZ45) 

- [Top 10 Mistakes Java Developers Make](http://www.gauravkgupta.com/top-10-mistakes-java-developers-make/)


- [Java Web Frameworks Index by RebelLabs](https://zeroturnaround.com/rebellabs/java-web-frameworks-index-by-rebellabs/)
 

## Syntax CheatSheet: 语法速览

- [Java Programming Cheatsheet From Princeton](http://introcs.cs.princeton.edu/java/11cheatsheet/): This appendix summarizes the most commonly-used Java language features in the textbook.

- [2017-Java 语法清单](https://zhuanlan.zhihu.com/p/25578170)


## Java 8

- [2017-Java 8 Tutorials](https://www.mkyong.com/tutorials/java-8-tutorials/): Some Java 8 examples, hope you like it.

- [2017-Java 8 Top Tips by Jetbrains](https://blog.jetbrains.com/idea/2016/07/java-8-top-tips/)



## Java 9

- [2016-Java 9 Features](http://www.journaldev.com/13121/java-9-features-with-examples): Oracle Corporation is going to release Java SE 9 around end of March 2017. In this post, I’m going to discuss about “Java 9 Features” briefly with some examples. 中文译文参考[这里](http://6me.us/UFu)。

- [2017-Top Resources to Get Started with Java 9](https://www.sitepoint.com/java-9-resources/)

- [Java 9 series: Variable Handles](https://www.voxxed.com/blog/2016/11/java-9-series-variable-handles/?utm_source=mybridge&utm_medium=ios&utm_campaign=read_more)

- [2017-Java 8 Vs. Java 9: Get Ready for a New Era](https://www.romexsoft.com/blog/java-8-vs-java-9/): Learn what’s new in Java 9 - a comprehensive overview for business owners and developers.

- [2016-A RevealJS overview presentation & example project of what to expect from Java 9 (Jul'2016)](https://github.com/bentolor/java9-in-action/blob/master/playground/src/main/java/de/exxcellent/java9/module-info.java) 

- [2017-Java 9 Articles – Series Index](https://blog.idrsolutions.com/2017/06/java-9-articles-series-index/): In this series we have put together some tutorials to explain what they are, why they are useful andquickly show you how to use them.

- [2017-Wrapping up Java 9 new Features](https://aboullaite.me/wrapping-up-java-9-new-features/): In this write up we’re going to have quick, high level look at some of the new features;


# Resource
## Book: 书籍

- [2011-深入理解Java虚拟机：JVM高级特性与最佳实践【Book】](https://parg.co/b1E)：全书共分为五大部分。第一部分从宏观的角度介绍了整个Java技术体系的过去、现在和未来；第二部分讲解了JVM的自动内存管理；第三部分分析了虚拟机的执行子系统；第四部分讲解了程序的编译与代码的优化；第五部分探讨了Java实现高效并发的原理。

- [2015-实战 Java 高并发程序设计]()：

- [2015-Pro Java 8 Programming, Third Edition #Project# ](https://www.safaribooksonline.com/library/view/pro-java-8/9781484206416/): Pro Java 8 Programming covers the core Java development kit and the finer points of the core standard edition (SE) and development kit version 8.

- [2017-Think Java【Book】](https://books.trinket.io/thinkjava/): Think Java is an excellent introduction to computer science and programming intended for people with little or no experience.



## Blog: 博客

- [Novixys Software Dev Blog【Blog】](http://www.novixys.com/blog/): [Using Timer Class to Schedule Tasks](http://www.novixys.com/blog/using-timer-schedule-tasks/)







# Online Playground: 在线实践与学习


# Collection: 其他资源集锦

- [2017-在Java路上，我看过的一些书、源码和框架【Collection】](http://www.jianshu.com/p/4a41ee88bd82)

- [Java 程序员们值得一看的好书推荐](https://zhuanlan.zhihu.com/p/23444919)

- [2017-Best Java Sites](http://www.baeldung.com/java-blogs): There are several “Top Java Blogs” pages out there – but also a lot of noise. Some of these blogs are abandoned with the last postin 2008, some have simply switched focused from Java to something else. Others are gone altogether.



## Interview: 面试

- [2017-Java Collection Interview Questions and Answer](https://parg.co/bak): Here is a list of Java Collections interview Questions. These are some of the famous questions asked in interviews.