[![返回目录](https://parg.co/UGo)](https://parg.co/b4z) 

# JavaScript 学习与实践资料索引

参考笔者在[泛编程语言学习知识结构](https://parg.co/bt0)一文中介绍的知识图谱了解目录划分原则，本文是 JavaScript 学习与实践资料索引的入口部分，关联子索引还包括：

# Overview

- [2017-A Brief History of JavaScript](https://auth0.com/blog/a-brief-history-of-javascript/): We take a look at the evolution of JavaScript, arguably one of the most important languages of today, and tomorrow

- [Everything I learned from #Javascript30](https://medium.com/craft-academy/everything-i-learned-from-javascript30-d8d2db246b7?source=userActivityShare-fe48c4221a4c-1488448383).





## CheatSheet

- [2017-JavaScript 核心概念归纳整理](https://mp.weixin.qq.com/s/I7A1iC8Et6uOGZ234DsTlA)：本文针对  JavaScript 语言的核心概念进行简单的梳理，对应的每个知识点仅仅点到为止，不作详细介绍。目的是为了方便大家快速审查自己对 JavaScript 的知识结构是否完善，如有遗漏或不正确的地方，还望批评指正。


- [Glossary of Modern JavaScript](https://auth0.com/blog/glossary-of-modern-javascript-concepts/): In this article, we'll address concepts that are crucial to understanding functional programming, reactive programming, and functional reactive programming and their use with JavaScript.


- [2017-Writing modern JavaScript code](https://dev.to/scastiel/writing-modern-javascript-code): I'll try here to list some good practices to make your JavaScript code easier to write, read and maintain.

- [2017-What the f*ck JavaScript?](https://github.com/denysdovhan/wtfjs#-is-equal-): A list of funny and tricky JavaScript examples

- [2017-Modern JavaScript Cheatsheet](https://github.com/mbeaudru/modern-js-cheatsheet): This document is a cheatsheet for JavaScript you will frequently encounter in modern projects and most contemporary sample code.


## 崛起的 JavaScript

- [2017-JavaScript — A First-Class Language At Last](https://hackernoon.com/javascript-a-first-class-language-at-last-209376f69731): As a JavaScript engineer, I wanted to dig deeper into the public perception of the language and how rooted in reality it is. What I found is that some criticisms hold water, but many do not.


# ECMAScript

- [TC39, ECMAScript, and the Future of JavaScript](https://parg.co/bXD)

- [简明 ES6 Features 列表](https://codetower.github.io/es6-features/)


- [The Real Story Behind ECMAScript 4](https://auth0.com/blog/the-real-story-behind-es4/): Our JavaScript history article sparked interesting comments regarding what really happened during the ECMAScript 4 era. Below you will find a more detailed perspective of what really went down between 1999 and 2008 in the world of JavaScript. Read on!

- [ES8 Feature Set: JavaScript is Getting Asynchronous](https://medium.com/@Eugeniya/es8-feature-set-javascript-is-getting-asynchronous-2a8a43dd0cbc#.brnqngo2n)

- [ECMAScript 2017 and beyond](https://speakerdeck.com/rauschma/ecmascript-2017-and-beyond): In this talk, we’ll go into the latest JavaScript features and how they are designed.

- [Mastering Async Await in Node.js](https://blog.risingstack.com/mastering-async-await-in-nodejs/): In this article, you will learn how you can simplify your callback or Promise based Node.js application with async functions (async/await).


# Collection: 资料集锦

- [Master JavaScript Programming With 18 OpenSource Books【Collection】](http://6me.us/snwXG): This compilation focuses on the JavaScript language with 18 solid recommendations. There are books here for beginner, intermediate, and advanced programmers alike. All of the texts are released under an open source license.

- [Awesome JavaScript【Collection】](https://github.com/sorrycc/awesome-javascript): A collection of awesome browser-side JavaScript libraries, resources and shiny things.

- [JavaScript-Garden](http://bonsaiden.github.io/JavaScript-Garden/): JavaScript Garden is a growing collection of documentation about the most quirky parts of the JavaScript programming language. It gives advice to avoid common mistakes and subtle bugs, as well as performance issues and bad practices, that non-expert JavaScript programmers may encounter on their endeavours into the depths of the language.


## Book

- [2017-The JavaScript Way](https://github.com/bpesquet/thejsway): A modern introduction to an essential language.

- [2015-ECMAScript 6 入门](http://es6.ruanyifeng.com/#README)：《ECMAScript 6 入门》是一本开源的 JavaScript 语言教程，全面介绍 ECMAScript 6 新引入的语法特性。

- [2015-ES6 in Depth【Book】](https://ponyfoo.com/articles/tagged/es6-in-depth)：A twenty-four article-long series of pragmatic articles describing JavaScript language features in ES6. 中文译本[深入浅出 ES6]()

- [2015-Exploring ES6](http://exploringjs.com/es6/index.html): Upgrade to the next version of JavaScript

- [2017-The Modern JavaScript Tutorial【Book】](https://javascript.info/): How it's done now. From the basics to advanced topics with simple, but detailed explanations.


# Interview

- [3 JavaScript questions to watch out for during coding interviews](http://6me.us/JAZ4): This article isn’t about the newest JavaScript libraries, common development practices, or any of the new ES6 functions. Rather, it’s about 3 things that usually come up in interviews when discussing JavaScript.

- [Interview Algorithm Questions in Javascript() {...}](https://github.com/kennymkchan/interview-questions-in-javascript)


- [2017-The Best Frontend JavaScript Interview Questions (written by a Frontend Engineer)](https://parg.co/bIL)

