# Web 开发样式指南资料索引

- [CSS Guildelines](https://cssguidelin.es/) - High-level advice and guidelines for writing sane, manageable, scalable CSS.
- [Frontend Guidelines](https://github.com/bendc/frontend-guidelines) - Some HTML, CSS and JS best practices.
- [Sass Guidelines](https://sass-guidelin.es/) - An opinionated styleguide for writing sane, maintainable and scalable Sass.
- [Airbnb CSS / Sass Styleguide](https://github.com/airbnb/css) - A mostly reasonable approach to CSS and Sass.
- [HTML + CSS Code Guide](http://codeguide.co/) - Standards for flexible, durable, and sustainable HTML and CSS.
- [U.S. Web Design Standards](https://standards.usa.gov/) - Open source UI components and visual style guide for U.S. government websites.
- [CoffeeScript Style Guide](https://github.com/polarmobile/coffeescript-style-guide) - A collection of best-practices and coding conventions for the CoffeeScript programming language.
- [LESS Coding Guidelines](https://gist.github.com/fat/a47b882eb5f84293c4ed)
- [Google HTML/CSS Style Guide](https://google.github.io/styleguide/htmlcssguide.html)
- [Guidelines for Responsive Web Design](https://www.smashingmagazine.com/2011/01/guidelines-for-responsive-web-design/)
- [Web 前端代码规范](https://parg.co/bXM)：此项目用于记录规范的、高可维护性的前端代码，这是通过分析 Github 众多前端代码库，总结出来的前端代码书写规范。

# JavaScript 与 DOM

- [airbnb-JavaScript Style Guide](https://github.com/airbnb/javascript)

- [阮一峰-JavaScript编程风格](http://javascript.ruanyifeng.com/grammar/style.html)

- [JavaScript Standard Style](https://github.com/feross/standard)

- [node-jscs:JavaScript Code Style checker](https://github.com/jscs-dev/node-jscs/)


# CSS

# HTML

