[![返回目录](https://parg.co/UGo)](https://parg.co/b4z)

# React 应用架构与性能优化资料索引




# StyleGuide: 样式指南



- [2017-Characteristics of an Ideal React Architecture](https://parg.co/bD4): 

- [2016-来自 AlloyTeam 的 React.js 2016最佳实践](http://www.alloyteam.com/2016/01/reactjs-best-practices-for-2016/)

- [2016-React Patterns](http://reactpatterns.com/):  Patterns for React Developers


- [2017-10 React mini-patterns](https://hackernoon.com/10-react-mini-patterns-c1da92f068c5#.5v2hpgurn): Over the last few years, I’ve worked on a handful of decent-sized React projects, and many, many pint-sized ones. Throughout this magical journey, a number of patterns have come up that I find myself repeating again and again.

- [Understanding Component-Based Architecture](https://medium.com/@dan.shapiro1210/understanding-component-based-architecture-3ff48ec0c238#.smfo6yyhj)

- [Share Code between React and React Apps using Higher Order Components](https://hackernoon.com/code-reuse-using-higher-order-hoc-and-stateless-functional-components-in-react-and-react-native-6eeb503c665#.4z4q9o6k2)

- [Higher Order React Components](http://natpryce.com/articles/000814.html)

- [Renderless Components or How Logic Doesn't Always Need a UI](http://kyleshevlin.com/renderless-components/)

- [Higher-Order Components in React](http://6me.us/MUHBdp)

- [jsinspect](https://github.com/danielstjules/jsinspect)


- [Our Best Practices for Writing React Components](https://medium.com/code-life/our-best-practices-for-writing-react-components-dec3eb5c3fc8#.mh12fzmoi)

- [2017-Avoiding deeply nested component trees](https://parg.co/beQ): By passing child components down instead of data you can avoid passing data down through many levels of components.


- [2017-Avoiding deeply nested component trees](https://parg.co/beQ): By passing child components down instead of data you can avoid passing data down through many levels of components.


- [2017-8 Key React Component Decisions](https://parg.co/Um6): Standardize your React development with these key decisions.


## CodeStyle: 代码风格

- [eslint-plugin-react #Project# ](https://parg.co/b11): React specific linting rules for ESLint.



## Functional React: 函数式 React



- [2017-Functional setState is the future of React](https://parg.co/bMW): Declare state changes separately from the component classes.

- [non-functional-react-js](https://medium.com/@arqex/non-functional-react-js-6e020ce27ee2#.cj3dcxl4j)

- [recompose #Project# ](https://github.com/acdlite/recompose/blob/master/docs/API.md#withstate): A React utility belt for function components and higher-order components.

- [2016-Why The Hipsters Recompose Everything](https://medium.com/javascript-inside/why-the-hipsters-recompose-everything-23ac08748198): Building a Utility Library for React

- [2017-Top 5 Recompose HOCs](https://parg.co/bJV): Today we’ll be going through my 5 (in no particular order) favorite Recompose Higher Order Components.

- [2017-Higher Order Components with Functional Patterns Using Recompose](https://egghead.io/courses/higher-order-components-with-functional-patterns-using-recompose): In this course, you will learn to use many of the most powerful and convenient higher-order components within Recompose by coding several real-world examples. Using recompose looks very different from “vanilla” React; so you will also get comfortable with the look and feel of a “recomposed” component. The best part is no more need for class components! You’ll learn how to use Recompose to both modify components and also create your own higher-order components.

- [Functional React Series — Part 1: Get your App outta my Component](https://medium.com/@adamterlson/functional-react-series-part-1-get-your-app-outta-my-component-92656ae13e25#.q47pt8fga)



## HOCs: 高阶组件



- [Presentational and Container Components](https://medium.com/@dan_abramov/smart-and-dumb-components-7ca2f9a7c7d0#.uz8irdipq)

- [2017-Why you should keep your react components pure by using HOCs](https://hackernoon.com/why-you-should-keep-your-react-components-pure-by-using-hocs-67e5c7f80c81): In this article I show how decomposing state from the presentational layer can both reduce complexity and promote code re-use with some React examples— a win-win situation helping to tame the challenges of developing SPAs. Although I’m using React, the lessons are universal and can apply to any framework.


- [redux-without-profanity-components](https://tonyhb.gitbooks.io/redux-without-profanity/content/components.html)

- [Mixins Are Dead. Long Live Composition](https://medium.com/@dan_abramov/mixins-are-dead-long-live-higher-order-components-94a0d2f9e750#.ldkxkz8na)

- [react-higher-order-components-in-depth](https://medium.com/@franleplant/react-higher-order-components-in-depth-cf9032ee6c3e#.wn52tt10t)

- [container-components](https://medium.com/@learnreact/container-components-c0e67432e005#.h775w7ifn)


- [2017-Understanding Higher Order Components](https://parg.co/biZ): Making sense of the rapidly changing React best practice.

- [React Higher Order Components in depth](https://medium.com/@franleplant/react-higher-order-components-in-depth-cf9032ee6c3e#.52i6nt3at)


- [2016-Building HOCs with Recompose](https://medium.com/front-end-developers/building-hocs-with-recompose-7debb951d101)



# Performance: 性能优化

- [React Office Site —— Optimizing Performance](https://facebook.github.io/react/docs/optimizing-performance.html): For many applications, using React will lead to a fast user interface without doing much work to specifically optimize for performance. Nevertheless, there are several ways you can speed up your React application.


- [2017-Keep Your React Redux Healthy, Performance Optimization Story](https://parg.co/bCn): I am here to be honest about React optimization.

- [2017-React at Light Speed](https://blog.vixlet.com/react-at-light-speed-78cd172a6411): Lessons in optimizing performance at Vixlet

- [2017-45% Faster React Functional Components, Now](https://parg.co/bMa)

- [2017-Our Best Practices for Writing React Components](https://engineering.musefind.com/our-best-practices-for-writing-react-components-dec3eb5c3fc8#.3kin14vrf): When I first started writing React, I remember seeing many different approaches to writing components, varying greatly from tutorial to tutorial. Though the framework has matured considerably since then, there doesn’t seem to yet be a firm ‘right’ way of doing things.

- [2017-Memoize React components](https://github.com/planttheidea/moize)

- [2017-React at Light Speed](http://6me.us/dx5)

- [Should I use shouldComponentUpdate?](http://jamesknelson.com/should-i-use-shouldcomponentupdate/)

- [React移动web极致优化](https://github.com/lcxfs1991/blog/issues/8?f=tt&hmsr=toutiao.io&utm_medium=toutiao.io&utm_source=toutiao.io)

- [ProReact中关于性能的章节]()

- [component-rendering-performance-in-react](https://medium.com/modus-create-front-end-development/component-rendering-performance-in-react-df859b474adc#.rjjvtwgs8)

- [React应用优化：避免不必要的render](http://www.broadview.com.cn/article/77?hmsr=toutiao.io&utm_medium=toutiao.io&utm_source=toutiao.io)

- [React Rally: Animated — React Performance Toolbox](http://blog.vjeux.com/2015/javascript/react-rally-animated-react-performance-toolbox.html)

- [How to Benchmark React Components: The Quick and Dirty Guide](https://medium.com/code-life/how-to-benchmark-react-components-the-quick-and-dirty-guide-f595baf1014c#.w1t22c86k)

- [React.js pure render performance anti-pattern](https://medium.com/@esamatti/react-js-pure-render-performance-anti-pattern-fb88c101332f#.b9vwbt1jy)

- [A DEEP DIVE INTO REACT PERF DEBUGGING](http://benchling.engineering/deep-dive-react-perf-debugging/)

- [React at 60fps](https://medium.com/@okonetchnikov/react-at-60fps-4e36b8189a4c#.enqkaabwg)

- [React Performance Optimization](https://medium.com/@nesbtesh/react-performance-optimization-28ec5b61fff3#.lx9g6ewdg)

- [React Performance Optimization](http://6me.us/t73W9): Performance optimization can be a big pain with any language. Especially when you are optimizing your app and you have no idea what to optimize. React has some really nice tools to do this, I will be talking about one specifically that will make your life a lot better.
-  [2017-React at Light Speed, Lessons in optimizing performance at Vixlet](https://blog.vixlet.com/react-at-light-speed-78cd172a6411): Here we will share some of the lessons we have learned along the way.

- [2017-Optimizing React Rendering](https://flexport.engineering/optimizing-react-rendering-part-1-9634469dca02)

- [2017-React, Inline Functions, and Performance](https://cdb.reacttraining.com/react-inline-functions-and-performance-bdff784f5578)


## Tool: 工具

- [High Performance React: 3 New Tools to Speed Up Your Apps](https://parg.co/b1v): In this post I’ll highlight tools and techniques for making React apps fast. Each section also has an interactive, and (hopefully) fun demo!

- [why-did-you-update #Project# ](https://github.com/garbles/why-did-you-update): Puts your console on blast when React is making unnecessary updates.





## Code Splitting & Components Decomposition: 代码分割与组件解耦



- [2017-React Loadable #Project# ](https://github.com/thejameskyle/react-loadable):  [2017-Introducing React Loadable](http://6me.us/mNHi)、[react-loadable-visibility #Project# ](https://github.com/stratiformltd/react-loadable-visibility)

- [2017-Code Splitting in Create React App](http://serverless-stack.com/chapters/code-splitting-in-create-react-app.html): This chapter is an extra step that can help speed up the initial load time of your React app.

- [2017-https://parg.co/bXz](https://parg.co/bXz): Techniques for decomposing React components. React components have a lot of power and flexibility. With so many tools at your disposal, it is incredibly easy for components to grow over time, become bloated and do too much.

- [2017-Writing Clean and Concise React Components by Making Full Use of ES6/7 Features and the Container-Component Pattern](https://parg.co/b1B)



