[![返回目录](https://parg.co/UGo)](https://parg.co/b4z) 


# Redux 学习与实践资料索引



- [2017-What’s So Great About Redux?](https://medium.freecodecamp.org/whats-so-great-about-redux-ac16f1cc0f8b)

- [2017-React Redux Cheat Sheet on Workflow & Concept](https://github.com/uanders/react-redux-cheatsheet): This article contains a graphical cheat sheet for the workflow and concept of Redux.



- [2017-Advanced Redux Entity Normalization](https://parg.co/bht): At Grovo we have been using an abstract structure we’ve taken to calling Key Windows.

- [2017-Learn Redux by coding a Mini-Redux](http://blog.jakoblind.no/2017/03/13/learn-redux-by-coding-a-mini-redux/): A different learning strategy is to code a simple Redux yourself to develop a deeper understanding of the fundamental principles of the library.

- [Understanding Redux](https://medium.com/front-end-hacking/understanding-redux-69798b1f8469#.l6u9zaavw)


- [From Zero to Redux in 3 Minutes A simplified guide to using Redux in a React application.](https://medium.com/@christiannaths/from-zero-to-redux-8db779b6ed01#.1j80ztr5q)



- [The difference between Flux and Redux](https://edgecoders.com/the-difference-between-flux-and-redux-71d31b118c1#.m1ho9k2jt)

- [Immutability in JavaScript using Redux](https://www.toptal.com/javascript/immutability-in-javascript-using-redux)

- [React and Redux Sagas Authentication App Tutorial](http://start.jcolemorrison.com/react-and-redux-sagas-authentication-app-tutorial/)

- [Redux 4 Ways](https://medium.com/react-native-training/redux-4-ways-95a130da0cdc#.xpa7z9ufe):Implementations of Thunk vs Saga vs Observable vs Redux Promise Middleware in 10 minutes.



- [Dissecting Twitter’s Redux Store](https://medium.com/statuscode/dissecting-twitters-redux-store-d7280b62c6b1#.wu5trgupx): 


- [How to use Redux on highly scalable javascript applications? ](http://6me.us/zue4re): Redux composition and encapsulation at large scale. Building a large scale application can be problematic, and as it grows it becomes more and more challenging and crucial to keep the structure organized. Redux provides great benefits from having a global application state, but on the other hand it can become messed up easily and break your app.



- [2017-Idiomatic Redux: The Tao of Redux【Series】](http://blog.isquaredsoftware.com/2017/05/idiomatic-redux-tao-of-redux-part-1/): Thoughts on what Redux requires, how Redux is intended to be used, and what is possible with Redux. [Part 1 - Implementation and Intent](http://blog.isquaredsoftware.com/2017/05/idiomatic-redux-tao-of-redux-part-1/) 


# Tutorial



- [How To Manage UI State With Redux](https://codeburst.io/how-to-manage-ui-state-with-redux-24deb6cf0d57): Questions regarding how to handle UI state are asked continuously on development boards, so I’d like to share with you how I maintain it. It’s a best practice that has improved the management of my applications.


# Resources 




## Book

- [2016-Developing a Redux Edge【Book】](https://parg.co/b4L): This book is for anyone wanting to learn about Redux, a predictable state container for JavaScript apps. It is aimed at intermediate developers who have a good understanding of creating single page applications with JavaScript. Having an understanding of ES6, functional programming, and React will certainly help too, but isn’t necessary. If you want to follow along with the examples you should also know your way around a terminal, and know what Node and npm are, as well as having them installed and ready to use.


# Async Action



- [2017-Moving API requests in React to Redux-Saga’s](https://hackernoon.com/moving-api-requests-to-redux-saga-21780f49cbc8)


# React



- [2017-Quick Redux tips for connecting your React components](https://medium.com/dailyjs/quick-redux-tips-for-connecting-your-react-components-e08da72f5b3)


# EPractices



- [2017-Five Tips for Working with Redux in Large Applications](https://parg.co/bIi): The following points of discussion should help anyone working with Redux on large, data intensive applications.

- [2017-探索Redux的最佳实践](http://mp.weixin.qq.com/s/DyUSg_J6t1C43PDJZi8GuQ)

- [2017-Redux for state management in large web apps](https://www.mapbox.com/blog/redux-for-state-management-in-large-web-apps/)

- [2017-Redux unit testing with Jest](https://medium.com/@btg5679/redux-unit-testing-with-jest-f3a18f387f75): This introductory tutorial focuses on writing tests for Redux enabled React apps, more specifically writing tests for your Actions and Reducers.

- [2017-10 Redux tips to scale your dev team](https://blog.matters.tech/10-redux-tips-from-the-trenches-55e06ed1c0a8)

## 样式指南


[A Better File Structure For React/Redux Applications](http://marmelab.com/blog/2015/12/17/react-directory-structure.html)
[my-journey-toward-a-maintainable-project-structure-for-react-redux](https://hackernoon.com/my-journey-toward-a-maintainable-project-structure-for-react-redux-b05dfd999b5#.uz1c90xd0)
[conventional-redux](https://github.com/mjaneczek/conventional-redux)
- [Scaling your Redux App with ducks](https://medium.com/@alexnm/scaling-your-redux-app-with-ducks-6115955638be#.r2wzfzmsv)




 

